Base64Encoder (Bouncy Castle Library 1.52 API Specification)
Date: 2015-03-01

org.bouncycastle.util.encoders

## Class Base64Encoder

- java.lang.Object
- - org.bouncycastle.util.encoders.Base64Encoder

- All Implemented Interfaces:
    Encoder
  Direct Known Subclasses:
    UrlBase64Encoder

      public class Base64Encoder
      extends java.lang.Object
      implements Encoder

  A streaming Base64 encoder.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected byte[]` | `decodingTable`
    `protected byte[]` | `encodingTable`
    `protected byte` | `padding`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Base64Encoder()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `decode(byte[] data, int off, int length, java.io.OutputStream out)` decode the base 64 encoded byte data writing it to the given output stream, whitespace characters will be ignored.
    `int` | `decode(java.lang.String data, java.io.OutputStream out)` decode the base 64 encoded String data writing it to the given output stream, whitespace characters will be ignored.
    `int` | `encode(byte[] data, int off, int length, java.io.OutputStream out)` encode the input data producing a base 64 output stream.
    `protected void` | `initialiseDecodingTable()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### encodingTable

          protected final byte[] encodingTable

    - #### padding

          protected byte padding

    - #### decodingTable

          protected final byte[] decodingTable

  - ### Constructor Detail

    - #### Base64Encoder

          public Base64Encoder()

  - ### Method Detail

    - #### initialiseDecodingTable

          protected void initialiseDecodingTable()

    - #### encode

          public int encode(byte[] data,
                   int off,
                   int length,
                   java.io.OutputStream out)
                     throws java.io.IOException

      encode the input data producing a base 64 output stream.
      Specified by:
        `encode` in interface `Encoder`
      Returns:
        the number of bytes produced.
      Throws:
        `java.io.IOException`

    - #### decode

          public int decode(byte[] data,
                   int off,
                   int length,
                   java.io.OutputStream out)
                     throws java.io.IOException

      decode the base 64 encoded byte data writing it to the given output stream, whitespace characters will be ignored.
      Specified by:
        `decode` in interface `Encoder`
      Returns:
        the number of bytes produced.
      Throws:
        `java.io.IOException`

    - #### decode

          public int decode(java.lang.String data,
                   java.io.OutputStream out)
                     throws java.io.IOException

      decode the base 64 encoded String data writing it to the given output stream, whitespace characters will be ignored.
      Specified by:
        `decode` in interface `Encoder`
      Returns:
        the number of bytes produced.
      Throws:
        `java.io.IOException`